题目描述

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的 两个 整数。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

  1. 给定 nums = [2, 7, 11, 15], target = 9
  2. 因为 nums[0] + nums[1] = 2 + 7 = 9
  3. 所以返回 [0, 1]

题解

官方的两遍哈希表法。

为了对运行时间复杂度进行优化,我们需要一种更有效的方法来检查数组中是否存在目标元素。如果存在,我们需要找出它的索引。保持数组中的每个元素与其索引相互对应的最好方法是什么?哈希表。

通过以空间换取速度的方式,我们可以将查找时间从 O(n)O(n) 降低到 O(1)O(1)。哈希表正是为此目的而构建的,它支持以 近似 恒定的时间进行快速查找。我用“近似”来描述,是因为一旦出现冲突,查找用时可能会退化到 O(n)O(n)。但只要你仔细地挑选哈希函数,在哈希表中进行查找的用时应当被摊销为 O(1)O(1)。

一个简单的实现使用了两次迭代。在第一次迭代中,我们将每个元素的值和它的索引添加到表中。然后,在第二次迭代中,我们将检查每个元素所对应的目标元素(target - nums[i]target−nums[i])是否存在于表中。注意,该目标元素不能是 nums[i]nums[i] 本身!

  1. public class Solution
  2. {
  3. public int[] TwoSum(int[] nums, int target)
  4. {
  5. var dictionary = new Dictionary<int, int>();
  6. for (var i = 0; i < nums.Length; i++)
  7. {
  8. dictionary[nums[i]] = i;
  9. }
  10. for (int i = 0; i < nums.Length; i++)
  11. {
  12. int complement = target - nums[i];
  13. if (dictionary.ContainsKey(complement) && dictionary[complement] != i)
  14. {
  15. return new[] { i, dictionary[complement] };
  16. }
  17. }
  18. throw new ArgumentException("No two sum solution");
  19. }
  20. }